/*
Randomizes (arcsine) a 2d array of float values 
as rhythms for the preprocessor cscore2.c file
J. Hearon 9/1/2011
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <sys/time.h>
#include <time.h>
#include <errno.h>

//NOT a 4d array with page, row, col, etc.
//but a 2d array with 4 cols
#define ASTRUCT_MAXROWS 1
#define ASTRUCT_MAXCOLS 1

struct the4dstruct
{
    int structnum;
    int nrows;
    int ncols;
    float a4dstruct[ASTRUCT_MAXROWS][ASTRUCT_MAXCOLS];
};


int randRange_ran4dstructs(int n)
{
    int top = ((((RAND_MAX-n)+1)/n)*n-1)+n;
    int r;
    do
    {
        r = rand();
    }
    while (r>top);
    return r%n;
}

//NOT a 4d array with page, row, col, etc.
//but a 2d array with 4 cols
float *random4dstructs(int inrows, int incols, float **input4darray, int returnrows, int returncols)
{
    int spinrows = returnrows;
    int spincols = returncols;
    int spincount = returnrows * returncols;
    int hh = inrows * incols;
    int h; //highest number
    int l = 1; //lowest number
    int f, i, j, k, n, x, y, forthnumrange;
    int rand(void);
    double r, u;
    float **s = NULL;  //the local 2d array
    float *sPool, *curS_Ptr; //for calloc
    float *ss = NULL; //local 1d arrays
    int *t = NULL;
    int *tt = NULL;

    struct the4dstruct **Arrayof4dStructs = NULL;
    struct timeval  t1; //structs for rand using time

first:
//*****************************************
//********  ALLOCATE MEMORY ***************
//*****************************************
//allocate local initialized 2d array memory, with 4 cols.
//NOTE: use of ptr pool for ease of freeing arrays later in the func
    s=(float **) calloc(spinrows+1, sizeof(float*));
    sPool = (float*)calloc(spincols*spinrows,sizeof(float));
    curS_Ptr=sPool;
    for (i = 0; i<spinrows+1; i++)
    {
        s[i]= curS_Ptr;
        curS_Ptr += spincols;
    }

    //allocate local initialized 1d array memory
    //Note: ss is different here from rhythm2d.c
    ss=(float *) calloc(spincount+1, sizeof(float*));
    t=(int *) calloc(spincount, sizeof(int*));
    tt=(int *) calloc(spincount, sizeof(int*));


//allocate memory for one 4d struct
    Arrayof4dStructs = (struct the4dstruct *)calloc(1, sizeof(struct the4dstruct));
//allocate memory for the inrows*incols num of 4dstructs
    h= inrows*incols;
    for (x=0; x<=h; x++)
    {
        /* add ONE element to the array */
        Arrayof4dStructs= (struct the4dstruct **)realloc(Arrayof4dStructs, (x + 1) * sizeof(struct the4dstruct *));
        /* allocate memory for x number of the4dstructs */
        Arrayof4dStructs[x] = (struct the4dstruct *)malloc(sizeof(struct the4dstruct));
    }

//load data from incoming 2d array to local array of structs
//structnums begin with '1' for ease of counting and printing,
//but structs begin with '0'
    x=0;
    y=1;
    for (j = 0; j<inrows; j++)
    {
        for (k = 0; k<incols; k++)
        {
            Arrayof4dStructs[x]->a4dstruct[0][0] = input4darray[j][k];
            Arrayof4dStructs[x]->structnum = y;
            x++;
            y++;
        }
    }

//load every fourth number into local 1d array (1,5,9,13,17,21...)
//hh=inrows, incols
    forthnumrange=1;
    for (x=1; x<=hh; x+=4)
    {
        t[forthnumrange] = x;
        forthnumrange++;
    }

//*****************************************************************
//********  RANDOMIZE array of structures (arcsine) ***************
//*****************************************************************

    h = forthnumrange;//highest equals the number of values + 1 (from forthnumrange++ above)

//spincount = returnrows * returncols
    for (x=1; x<=spincount/4; x++)
    {
next:
        gettimeofday(&t1, NULL);
        srand(t1.tv_usec * t1.tv_sec);

        r = ((double)rand()/((double)(RAND_MAX)+(double)(1))); /*scales value of 'r' to 0..1 */
        r = r + randRange_ran4dstructs(2); //makes 'top' of the range 1.  Thus 0 > r < 2.
        //adjust top when RAND_MAX will not allow random selections
        //in the algorithms below.
        //printf(" %4.6f ", r);//DEBUG

        u = pow(sin(3.1459*(double)r/(double)2),2); //arcsine dist
        f = (int)(u*h-1)+1; //limits between ranges
        if(h == 1)   //avoids rare case where highest = 1
        {
            if(f<l || f>h)
            {
                goto next;
            }
        }
        else
        {
            if(f<l || f>h-1)  /*avoid out of bounds nums */
            {
                goto next;
            }
        }

        tt[x]= t[f];
    } //end for loop
//+++++++++++++++++++++

//*********************************************************
//********  LOADING and PRINTING spun array ***************
//*********************************************************
// Fill All slots
// uses the randomized numbers, from above
    x=0;
    for(i=1; i<=spincount/4; i++)
    {
        n=tt[i];
        x=x+1;
        ss[x]=Arrayof4dStructs[n-1]->a4dstruct[0][0]; //1, 5, 9, 13, 17, 21 ...
        x=x+1;
        ss[x]=Arrayof4dStructs[n]->a4dstruct[0][0];   //2, 6, 10, 14, 18, 22...
        x=x+1;
        ss[x]=Arrayof4dStructs[n+1]->a4dstruct[0][0]; //3, 7, 11, 15, 19, 23...
        x=x+1;
        ss[x]=Arrayof4dStructs[n+2]->a4dstruct[0][0]; //4, 8, 12, 16, 20, 24...
    }

// loads the 1d array into a 2d array to return to the
// RHY4DINPUT func below
    printf("...printing the spincount of 2d spun structs (from rand4dstructs)...\n");
    i=0;
    for (j = 0; j<spinrows; j++)
    {
        for (k = 0; k<spincols; k++)
        {
            i++;
            s[j][k] = ss[i];
            printf("%d: %4.6f\n", i, s[j][k]);
        }
    }

//should be a switch here to do another spin before returning values
    printf("\ntry again? 1 for yes, 2 for no: ");
    scanf("%d", &n);
    switch (n)
    {
    case 1:
        //free ALL memory allocated so far
        for (x=0; x<=h; x++)
        {
            free(Arrayof4dStructs[x]);
        }
        free (Arrayof4dStructs);
        free(*s);
        free(s);
        free(ss);
        free(t);
        free(tt);
        goto first;
        break;
    case 2:
        printf("\nbye");
        break;
    }//ends switch
    printf("\n");

    for (x=0; x<=h; x++)
    {
        free(Arrayof4dStructs[x]);
    }
    free (Arrayof4dStructs);
    free(ss);  
    free(t);
    free(tt);

    return s; //return only the local array of randomized nums
    //not the whole struct

} //end random4dstructs

//++++++++++++++++++++++++++++++++
//++++++++++++++++++++++++++++++++
//++++++++++++++++++++++++++++++++
//++++++++++++++++++++++++++++++++

//******   RHY4DINPUT    ******

//++++++++++++++++++++++++++++++++
//++++++++++++++++++++++++++++++++
//++++++++++++++++++++++++++++++++
//++++++++++++++++++++++++++++++++

//NOT a 4d array with page, row, col
//but a 2d array with 4 cols
float *rhy4Dinput(float *rhy4Dreturnarray)
{
    float **struct4dinputarray = NULL; //local 2d array with 4 cols
    float **struct4dreturnarray = NULL; //locadl 2d array with 4 cols
    float  *struct1dreturnarray = NULL;
    int i, j, k, n, x;
    int rows, spinrows;  //number of input rows and returned rows
    int cols = 4;  //one input pair (for 4d leave cols as "4")
    int spincols = 4; //one returned group of three
    float *inputPool, *returnPool; //for calloc
    float *curInputPtr, *curReturnPtr; //for calloc

//**************************************
//********  ENTER VALUES ***************
//**************************************
//fill a 2d array, with 4 cols, to send to rand3dsturcts function
start:
    printf("\n");
    printf("Enter the number of tetrads: ");
    scanf("%d",&rows);
//printf("\nThe number of pairs is: %d", rows);

//allocate regular 2d array memory
//keep 2d array as 3 cols
//But rows * num of pairs are needed for input
//NOTE: use of ptr pool for ease of freeing arrays later in the func
    struct4dinputarray=(float **) calloc(rows, sizeof(float*));
    inputPool = (float*)calloc(cols*rows,sizeof(float));
    curInputPtr=inputPool;
    for (i = 0; i<rows; i++)
    {
        struct4dinputarray[i]= curInputPtr;
        curInputPtr += cols;
    }

//load the 2d array with rhythmic tetrads, ex:
//(0,0)=0.25, (0,1)=0.25, (0,2)=0.25, (0,3)=0.25
//(1,0)=0.5, (1,1)=0.5, (1,2)=0.5, (1,3)=0.5, etc.
    x=1;
    for (j = 0; j<rows; j++)
    {
        for (k = 0; k<cols; k++)
        {
            printf("Tetrad #%d, enter value #%d: ", j, x);
            scanf("%f",&struct4dinputarray [j][k]);
            x++;
        }
    }

    printf("\n...here's the list \n");
    for (j = 0; j<rows; j++)
    {
        for (k = 0; k<cols; k++)
        {
            printf("%2.4f\n",  struct4dinputarray[j][k]); // Displaying the Array
        }
    }

//switch for another spin before returning values
    printf("\ntry again? 1 for yes, 2 for no: ");
    scanf("%d", &n);
    switch (n)
    {
    case 1:
        //free 2d array memory
//NOTE: this how ptr pool helps with freeing memory
        free(*struct4dinputarray);
        free(struct4dinputarray);
        goto start;
        break;
    case 2:
        goto next;
        break;
    }//ends switch
    printf("\n");
//**************************************
//********  RETURN VALUES ***************
//**************************************
next:
//number of groups of four to be returned
    printf("\nEnter the number of tetrads to be returned: ");
    scanf("%d",&spinrows);

//allocate 1d array memory
    struct1dreturnarray=(float **) calloc((spinrows*spincols), sizeof(float*));

//allocate 2d array memory, with four cols
//NOTE: use of ptr pool for ease of freeing arrays later in the func
    struct4dreturnarray=(float **) calloc(spinrows, sizeof(float*));
    returnPool = (float*)calloc(spincols*spinrows,sizeof(float));
    curReturnPtr = returnPool;
    for (i = 0; i<spinrows; i++)
    {
        struct4dreturnarray[i]= curReturnPtr;
        curReturnPtr += spincols;
    }

    struct4dreturnarray = random4dstructs(rows, cols, struct4dinputarray, spinrows, spincols);

// convert the 2d array from random4dstructs function to a 1d array
// to RETURN to main, for use with Cscore
//printf("testing return\n");
    x=0;
    for (j = 0; j<spinrows; j++)
    {
        for (k = 0; k<spincols; k++)
        {
            x++;
            struct1dreturnarray[x] = struct4dreturnarray[j][k]; 
        }
    }

    //free 2d array memory
//NOTE: this how ptr pool helps with freeing memory
    free(*struct4dinputarray);
    free(struct4dinputarray);

    free(*struct4dreturnarray);
    free(struct4dreturnarray);

    return struct1dreturnarray;   //returns a 1d array of rhythms

} //end rhy4dinput

